# -*- coding: utf-8 -*-
"""
Created on Thu Oct 13 15:37:57 2022

@author: MGeront
"""

# Nuclear Lab
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
from datetime import datetime

#import csv data
data_all = pd.read_csv('F:/01. ΦΥΣΙΚΟ ΑΘΗΝΑΣ/4ο Ετος/1ο Εξάμηνο/Εργαστήριο Πυρηνικής/P1/P1_1.csv',header=0, delimiter=';')
data_all["DATE"]=pd.to_datetime(data_all["DATE"])
dates=data_all["DATE"]
oulu=data_all["OULU"].values
athn = data_all["ATHN"].values
apty = data_all["APTY"].values
data_all["THUL"] = pd.to_numeric(data_all["THUL"], errors='coerce')
thul=data_all["THUL"].values

#διαγραμμ0ατα με τις τιμες όλων των σταθμων απο 10-17/10

#oulu
plt.figure(num=1,dpi=120)
plt.plot(dates,oulu)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού OULU από 10/12/2006 - 17/12/2006")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.show()

#athn
plt.figure(num=2,dpi=120)
plt.plot(dates,athn)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού ATHN από 10/12/2006 - 17/12/2006")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.show()

#apty
plt.figure(num=3,dpi=120)
plt.plot(dates,apty)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού APTY από 10/12/2006 - 17/12/2006")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.show()

#thul
plt.figure(num=4,dpi=120)
plt.plot(dates,thul)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού THUL από 10/12/2006 - 17/12/2006")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.show()

#filtering
start_date="12/13/2006 01:00"
end_date="12/13/2006 05:00"
data_all['DATE']=pd.to_datetime(data_all['DATE'])
filtered_data=data_all.loc[(data_all['DATE']>start_date) & (data_all['DATE']<end_date) ]
dates_filtered=filtered_data['DATE']
oulu_filtered=filtered_data['OULU'].values
athn_filtered=filtered_data['ATHN'].values
apty_filtered=filtered_data['APTY'].values
thul_filtered=filtered_data['THUL'].values

#διαγραμματα με τις τιμες όλων των σταθμων απο 13/12 01:00 - 13/12 05:00

#oulu
plt.figure(num=5,dpi=120)
plt.plot(dates_filtered,oulu_filtered)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού OULU από 13/12 01:00 - 13/12 05:00")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.grid()
plt.show()

#athn
plt.figure(num=6,dpi=120)
plt.plot(dates_filtered,athn_filtered)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού ATHN από 13/12 01:00 - 13/12 05:00")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.grid()
plt.show()

#apty
plt.figure(num=7,dpi=120)
plt.plot(dates_filtered,apty_filtered)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού APTY από 13/12 01:00 - 13/12 05:00")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.grid()
plt.show()

#thul
plt.figure(num=8,dpi=120)
plt.plot(dates_filtered,thul_filtered)
plt.xticks(rotation=80)
plt.title("Δεδομένα Σταθμού THUL από 13/12 01:00 - 13/12 05:00")
plt.ylabel("Counts per Second")
plt.xlabel("UTC")
plt.grid()
plt.show()

#selection for mean value
selection_start="12/13/2006 01:00"
selection_end="12/13/2006 05:00"
nmdb_sel=filtered_data.loc[(filtered_data['DATE']>selection_start) & (filtered_data['DATE']<selection_end)]

#0ulu
oulu_selected=nmdb_sel["OULU"].values
athn_selected=nmdb_sel['ATHN'].values
apty_selected=nmdb_sel['APTY'].values
thul_selected=nmdb_sel['THUL'].values
mean_val_oulu = np.mean(oulu_selected)
mean_val_athn = np.mean(athn_selected)
mean_val_apty = np.mean(apty_selected)
mean_val_thul = np.mean(thul_selected)

results_oulu=(oulu_filtered - mean_val_oulu)/mean_val_oulu
results_athn=(athn_filtered - mean_val_athn)/mean_val_athn
results_apty=(apty_filtered - mean_val_apty)/mean_val_apty
results_thul=(thul_filtered - mean_val_thul)/mean_val_thul

#εύρεση μέγιστης τιμής και χρονου για κάθε σταθμό
oulu_max=np.max(results_oulu)
print(oulu_max)
athn_max=np.max(results_athn)
print(athn_max)
apty_max=np.max(results_apty)
print(apty_max)
thul_max=np.max(results_thul)
print(thul_max)



plt.figure(num=9,dpi=120)
plt.title("Κανονικοποιημένα Δεδομένα όλων των Σταθμών \n από 13/12 01:00 - 13/12 05:00")
plt.plot(dates_filtered,results_oulu,color='r',label='oulu')
plt.plot(dates_filtered,results_athn,color='g',label='athn')
plt.plot(dates_filtered,results_apty,color='b',label='apty')
plt.plot(dates_filtered,results_thul,color='y',label='thul')
plt.xlabel("UTC")
plt.ylabel("(Ii-Im)/Im")
plt.xticks(rotation=80)
plt.grid()
plt.legend()
plt.show()


